<template>
  <div class="priceList">
    <el-row>
      <el-col :span="4" style="width: 200px">
        <search-metal-kind
          :value="parmValue.type"
          :disabled="false"
          :isDetail="false"
          :size="searchSize"
          :placeholder="'金属类型'"
          @searchChange="noble_metalsearchChange"
        />
      </el-col>
      <el-col :span="4" style="width: 170px; padding: 0 0 0 10px">
        <el-input
          :size="searchSize"
          v-model="parmValue.company_name"
          :maxlength="40"
          @blur="

            searchList
          "
          placeholder="创建人部门"
        ></el-input>
      </el-col>
      <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
        <el-button type="primary" :size="searchSize" @click="searchList">
          刷新
        </el-button>
      </el-col>
      <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
        <el-button type="warning" :size="searchSize" @click="restSearch">
          重置
        </el-button>
      </el-col>
      <el-col
        :span="3"
        class="fr"
        style="width: 66px; padding: 0 0 0 10px"
        v-if="powers.some((i) => i == '003')"
      >
        <el-button
          :size="searchSize"
          type="success"
          style="float: right"
          @click="openModal({}, '003')"
        >
          添加
        </el-button>
      </el-col>
      <el-col :span="24" style="padding: 10px 0 0 0">
        <el-table
          :data="tableData"
          border
          stripe
          :size="'mini'"
          style="width: 100%"
        >
          <el-table-column prop="type_cn" label="贵金属种类" width="180" />
          <el-table-column prop="price" label="当前金价(元/g)" width="180" />
          <el-table-column label="状态">
            <template slot-scope="scope">
              <el-tag
                :size="tablebtnSize"
                :type="scope.row.status == '0' ? 'warning' : ''"
                v-text="
                  (
                    statusOptions.find((item) => item.id == scope.row.status) ||
                    {}
                  ).label || '--'
                "
              ></el-tag
            ></template>
          </el-table-column>
          <el-table-column prop="company_name" label="创建人部门" />

          <el-table-column prop="action_name" label="创建人" />
          <el-table-column prop="addtime" label="创建时间" />
          <el-table-column label="操作">
            <template slot-scope="scope">
              <el-tooltip
                v-if="powers.some((i) => i == '007')"
                effect="dark"
                content="详情"
                placement="top"
              >
                <i
                  class="el-icon-view tb-icon"
                  @click="openModal(scope.row, '007')"
                ></i>
              </el-tooltip>
              <el-tooltip
                v-if="powers.some((i) => i == '005')"
                effect="dark"
                content="修改"
                placement="top"
              >
                <i
                  class="el-icon-edit tb-icon"
                  @click="openModal(scope.row, '005')"
                ></i>
              </el-tooltip>
              <el-tooltip
                v-if="
                  powers.some((i) => i == '004') &&
                  scope.row.status === '1'
                "
                effect="dark"
                content="禁用"
                placement="top"
              >
                <i
                  class="el-icon-video-pause tb-icon"
                  @click="changeStatus(scope.row.id, scope.row.status)"
                ></i>
              </el-tooltip>
              <el-tooltip
                v-if="
                  powers.some((i) => i == '004') &&
                  scope.row.status === '0'
                "
                effect="dark"
                content="启用"
                placement="top"
              >
                <i
                  class="el-icon-video-play tb-icon"
                  @click="changeStatus(scope.row.id, scope.row.status)"
                ></i>
              </el-tooltip>
              <el-tooltip
                v-if="powers.some((i) => i == '006')"
                effect="dark"
                content="删除"
                placement="top"
              >
                <i
                  class="el-icon-delete tb-icon"
                  @click="deleteItem(scope.row.id)"
                ></i> </el-tooltip
            ></template>
          </el-table-column>
        </el-table>
      </el-col>
    </el-row>

    <!-- 弹窗 新增/修改 -->
    <add-edit
      :id="modelId"
      :show-model="showModel"
      :sitem="sitem"
      @refresh="searchList"
      @cancel="showModel = false"
    />
  </div>
</template>
<script>
import addEdit from "./addEdit";
import asyncRequest from "@/apis/service/goodStore/goldPrice";
import mixinPage from "@/mixins/elPaginationHandle";
import { mapGetters } from "vuex";
import resToken from "@/mixins/resToken";
export default {
  name: "goldPrice",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "goldPrice"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      loading: true,
      showModel: false,
      modelId: "000",
      sitem: {},
      parmValue: {
        company_name: "", //创建人部门
        type: "",
      },
      // 状态
      statusOptions: [
        { id: "0", label: "禁用" },
        { id: "1", label: "启用" },
      ],
      // 表格 - 数据
      tableData: [],
    };
  },
  mounted() {
    this.searchList();
  },
  methods: {
    async restSearch() {
      this.parmValue = {
        company_name: "", //创建人部门
        type: "",
      };
      await this.searchList();
    },
    // 新建/编辑/详情
    openModal(row, type) {
      this.sitem = row;
      this.modelId = type;
      this.showModel = true;
    },
    //贵金属种类选择
    async noble_metalsearchChange(e) {
      const { id, code, label } = e;
      if (id) {
        this.parmValue.type = id;
      } else {
        this.parmValue.type = "";
      }
      await this.searchList();
    },
    /**
     * 启用/禁用
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async changeStatus(id, status) {
      await this.$confirm(`确定要改为${status === "1" ? "禁用" : "启用"}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.loading = false;
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async deleteItem(id) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 刷新表格
    async searchList() {
      this.loading = true;
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data;
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
      }
      this.loading = false;
    },
  },
};
</script>

<style lang="scss" scoped>
</style>
